<?php

/**
 * Settings.php
 * @author starr-gaming.com
 * @copyright 2010
 */

if (!defined("VALID_PHP"))
	die('Direct access to this location is not allowed.');

if(isset($_POST['submit']))
{
	$return = $settings->updateSettings();
	$settings->set = $settings->getSettings();
}

?>
<?php display_message(); ?>
<h1>Settings</h1>
<form action="index.php?page=settings" method="post">
<table class="box">
	<thead>
		<tr>
			<th colspan="2">Site Settings</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>Site Name:</td>
			<td>
				<input type="text" class="input" name="site_name" value="<?php echo $settings->set['site_name']; ?>" />
				<img src="images/info.png" title="The name of your site." class="tooltip" />
			</td>
		</tr>
		<tr>
			<td>Site URL:</td>
			<td>
				<input type="text" class="input" name="site_url" value="<?php echo $settings->set['site_url']; ?>" />
				<img src="images/info.png" title="The URL of your site, eg: http://www.yoursite.com" class="tooltip" />
			</td>
		</tr>
		<tr>
			<td>Admin Email:</td>
			<td>
				<input type="text" class="input" name="site_email" value="<?php echo $settings->set['site_email']; ?>" />
				<img src="images/info.png" title="The is the email address from which all emails will be sent." class="tooltip" />
			</td>
		</tr>
		<tr>
			<td>Meta Keywords:</td>
			<td>
				<textarea class="textarea" name="site_meta_keywords"><?php echo $settings->set['site_meta_keywords']; ?></textarea>
				<img src="images/info.png" title="The default meta keywords to display." class="tooltip" />
			</td>
		</tr>
		<tr>
			<td>Meta Description:</td>
			<td>
				<textarea class="textarea" name="site_meta_description"><?php echo $settings->set['site_meta_description']; ?></textarea>
				<img src="images/info.png" title="The default meta description to display." class="tooltip" />
			</td>
		</tr>
		<tr>
			<td>Sites Per Page:</td>
			<td>
				<input type="text" class="input" name="site_per_page" size="5" value="<?php echo $settings->set['site_per_page']; ?>" />
				<img src="images/info.png" title="This is the number of site that will be shown per page." class="tooltip" />
			</td>
		</tr>
		<tr>
			<td>Enable Captcha:</td>
			<td>
				<input type="radio" value="On" name="site_captcha" <?php if($settings->set['site_captcha']=='On') echo 'checked=checked';?> />On &nbsp;&nbsp; 
				<input type="radio" value="Off" name="site_captcha" <?php if($settings->set['site_captcha']=='Off') echo 'checked=checked';?> />Off 
				<img src="images/info.png" title="Captcha verification for registration (Recommend On)." class="tooltip" />
			</td>
		</tr>
		<tr>
			<td>Email Verification:</td>
			<td>
				<input type="radio" value="On" name="site_email_verification" <?php if($settings->set['site_email_verification']=='On') echo 'checked=checked';?> />On &nbsp;&nbsp; 
				<input type="radio" value="Off" name="site_email_verification" <?php if($settings->set['site_email_verification']=='Off') echo 'checked=checked';?> />Off 
				<img src="images/info.png" title="Require email verification after a user registers. (Recommend On)" class="tooltip" />
			</td>
		</tr>
		<tr>
			<td>Site Verification:</td>
			<td>
				<input type="radio" value="On" name="site_admin_site_activation" <?php if($settings->set['site_admin_site_activation']=='On') echo 'checked=checked';?> />On &nbsp;&nbsp; 
				<input type="radio" value="Off" name="site_admin_site_activation" <?php if($settings->set['site_admin_site_activation']=='Off') echo 'checked=checked';?> />Off 
				<img src="images/info.png" title="Manual activation by the admin of submitted sites. (Recommend On)" class="tooltip" />
			</td>
		</tr>
		<tr>
			<td>Enable Ads:</td>
			<td>
				<input type="radio" value="On" name="site_ads" <?php if($settings->set['site_ads']=='On') echo 'checked=checked';?> />On &nbsp;&nbsp; 
				<input type="radio" value="Off" name="site_ads" <?php if($settings->set['site_ads']=='Off') echo 'checked=checked';?> />Off 
				<img src="images/info.png" title="Display ad banners on the site. Ads are located in /install_path/banners" class="tooltip" />
			</td>
		</tr>
	</tbody>
	<tfoot>
		<tr>
			<td colspan="2"><input type="submit" name="submit" class="button" value="Update" /></td>
		</tr>
	</tfoot>
</table>
</form>