<?php

/**
 * Templates.php
 * @author starr-gaming.com
 * @copyright 2010
 */

if (!defined("VALID_PHP"))
	die('Direct access to this location is not allowed.');
 
if(isset($_POST['submit']))
{
	if($settings->updateTemplate($_GET['id']))
		$msg_ok = 'You have updated the email template.';
}

if(isset($_GET['id']))
{
	$template = $settings->getTemplate($_GET['id']);
	if(!$template)
		$msg_error[] = 'That email template cannot be found.';
}
else
{
	$rows = $settings->getTemplate('all');
}

?>
<?php display_message() ?>
<h1>Email Templates</h1>
<?php if(isset($template)): ?>
<script type="text/javascript">
tinyMCE.init({
	mode : "textareas", 
	theme : "advanced", 
	
	theme_advanced_toolbar_location : "top",
	theme_advanced_toolbar_align : "left",
	theme_advanced_statusbar_location : "bottom",
	theme_advanced_resizing : true,		
	plugins : "table,advhr,advimage,advlink,emotions,insertdatetime,preview,searchreplace,print,contextmenu",
	extended_valid_elements : "a[name|href|target|title|onclick],img[class|src|border=0|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name],hr[class|width|size|noshade],font[face|size|color|style],span[class|align|style]",
	theme_advanced_buttons1_add : "fontselect,fontsizeselect",
	theme_advanced_buttons2_add : "separator,insertdate,inserttime,zoom,separator,forecolor,backcolor",
	theme_advanced_buttons2_add_before: "cut,copy,paste,separator,preview,search,replace,separator",
	theme_advanced_buttons3_add_before : "tablecontrols,separator",
	theme_advanced_buttons3_add : "emotions,iespell,flash,advhr,separator,print",
	content_css : "/assets/style.css",	
	force_br_newlines : true,
	force_p_newlines : false,
	forced_root_block : ''

});
</script>

<form action="index.php?page=templates&id=<?php echo $template['template_id'] ?>" method="post">
<table class="box">
	<thead>
		<tr>
			<th colspan="2">Editing <?php echo $template['template_name'] ?></th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>Template Title: </td>
			<td><input type="text" class="input" name="template_name" value="<?php echo $template['template_name'] ?>" /></td>
		</tr>
		<tr>
			<td>Email Subject: </td>
			<td><input type="text" class="input" name="template_subject" value="<?php echo $template['template_subject'] ?>" /></td>
		</tr>
		<tr>
			<td>Email Body: </td>
			<td class="none">
				<textarea name="template_body" class="textarea"><?php echo $template['template_body'] ?></textarea>
			</td>
		</tr>
	</tbody>
	<tfoot>
		<tr>
			<td colspan="2"><input type="submit" class="button" name="submit" value="Submit" /></td>
		</tr>
	</tfoot>
</table>
</form>
<?php else: ?>
<table class="box">
	<thead>
		<tr>
			<th colspan="2">Select Template to Edit</th>
		</tr>
	</thead>
	<tbody>
		<?php foreach($rows AS $row): ?>
		<tr>
			<td><?php echo $row['template_name'] ?></td>
			<td><a href="index.php?page=templates&id=<?php echo $row['template_id'] ?>">Edit</a></td>
		</tr>
		<?php endforeach; ?>
	</tbody>
</table>
<?php endif; ?>