<?php

/**
 * Class class_settings.php
 * @author starr-gaming.com
 * @copyright 2010
 */
 
if (!defined("VALID_PHP"))
	die('Direct access to this location is not allowed.');

class Settings
{
	public $set = array();
	
	function __construct()
	{
		$this->set = $this->getSettings();
	}
	
	public function sendEmail($user_email)
	{
		global $db, $msg_error, $mailer, $user;
		$row = $db->first("SELECT user_name FROM users WHERE user_email LIKE '" . $user_email . "' LIMIT 1");
		$search = array("[USER_NAME]", "[SITE_NAME]", "[SITE_URL]");
		$replace = array($row['user_name'], $this->set['site_name'], $this->set['site_url']);
		$body = str_replace($search, $replace, $_POST['email_body']);
		$mailer->sendMail($user_email, $_POST['email_subject'], $body);
		return true;
	}
	
	public function massEmail()
	{
		global $db, $msg_error, $mailer;
		$rows = $db->fetch_all("SELECT user_email, user_name FROM users WHERE user_active = 'Yes'");
		foreach($rows AS $row)
		{
			$search = array("[USER_NAME]", "[SITE_NAME]", "[SITE_URL]");
			$replace = array($row['user_name'], $this->set['site_name'], $this->set['site_url']);
			$body = str_replace($search, $replace, $_POST['email_body']);
			$mailer->sendMail($row['user_email'], $_POST['email_subject'], $body);
		}
		return true;
	}
	
	public function updateTemplate($id)
	{
		global $db, $msg_error;
		if(empty($_POST['template_name']))
			$msg_error[] = 'You must specify a template name.';
		if(empty($_POST['template_subject']))
			$msg_error[] = 'You must specify a template subject.';
		if(empty($_POST['template_body']))
			$msg_error[] = 'You must specify a template body.';
			
		if(empty($msg_error))
		{
			$data = array("template_name" => sanitize($_POST['template_name']), "template_subject" => sanitize($_POST['template_subject']), "template_body" => $_POST['template_body']);
			$db->update("templates", $data, "template_id = " . intval($id));
			return true;
		}
		return false;
	}
	
	public function getTemplate($id)
	{
		global $db;
		if($id == 'all')
		{
			return $db->fetch_all("SELECT * FROM templates ORDER BY template_name ASC");
		}
		else
		{
			$sql = $db->query("SELECT * FROM templates WHERE template_id = " . intval($id) . " LIMIT 1");
			if($db->numrows($sql))
				return $db->fetch($sql);
		}
		return false;
	}
	
	public function updateSettings()
	{
		global $db, $msg_error, $msg_ok;
		if(empty($_POST['site_name']))
			$msg_error[] = 'You must enter a site name.';
		if(empty($_POST['site_url']))
			$msg_error[] = 'You must enter a site URL.';
		if(empty($_POST['site_email']))
			$msg_error[] = 'You must enter a site email address.';
			
		if(empty($msg_error))
		{
			$data = array(
				"site_name" => sanitize($_POST['site_name']), 
				"site_url" => sanitize($_POST['site_url']), 
				"site_email" => sanitize($_POST['site_email']), 
				"site_meta_keywords" => sanitize($_POST['site_meta_keywords']), 
				"site_meta_description" => sanitize($_POST['site_meta_description']), 
				"site_per_page" => sanitize($_POST['site_per_page']), 
				"site_captcha" => sanitize($_POST['site_captcha']), 
				"site_email_verification" => sanitize($_POST['site_email_verification']), 
				"site_admin_site_activation" => sanitize($_POST['site_admin_site_activation']),
				"site_ads" => sanitize($_POST['site_ads']), 
			);
			$db->update("settings", $data);
			$msg_ok = 'The site settings have been updated.';
			return true;
		}
		return false;
	}
	
	public function getSettings()
	{
		global $db;
		$row = $db->first("SELECT * FROM settings");
		if($row)
			return $row;
		else
			return false;
	}
}


?>