<?php

/**
 * Class class_sites.php
 * @author starr-gaming.com
 * @copyright 2010
 */

if (!defined("VALID_PHP"))
	die('Direct access to this location is not allowed.');

class Sites
{
	public $all_votes = array();

	function __construct()
	{

	}
	
	public function getSiteSort()
	{
		$array = array(
			"NA" => " -- Reset Sort -- ", 
			"site_id-DESC" => "Newest",
			"site_id-ASC" => "Oldest",
			"site_name-ASC" => "Name &uarr;",
			"site_name-DESC" => "Name &darr;",
			"site_votes-ASC" => "Votes &uarr;",
			"site_votes-DESC" => "Votes &darr;",
			"site_clicks-ASC" => "Clicks &uarr;",
			"site_clicks-DESC" => "Clicks &darr;",
		);
		$return = "";
		foreach($array AS $key =>$value)
		{
			$selected = "";
			if(isset($_GET['sort']) && $key == $_GET['sort'])
				$selected = 'selected=selected';
			$return .= '<option value="'.$key.'" '.$selected.'>'.$value.'</option>';
		}
		return $return;
	}
	
	public function deleteSite($site_id)
	{
		global $db, $msg_error;
		$sql = $db->query("DELETE FROM sites WHERE site_id = " . $site_id . " LIMIT 1");
		return true;
	}
	
	public function approveSite($site_id)
	{
		global $db, $settings, $mailer, $msg_error;
		$row = $db->first("SELECT s.site_name, u.user_name, u.user_email FROM sites s LEFT JOIN users u ON u.user_id = s.site_owner WHERE site_id = ".$site_id." LIMIT 1");
		if($row)
		{
			$data['site_active'] = 'Yes';
			$db->update("sites", $data, "site_id=".$site_id);
				//mail user with activation code
			$template = $settings->getTemplate(3);
			$link = $settings->set['site_url'] . '/index.php?page=site_view&id=' . $site_id;
			$search = array("[USER_NAME]", "[SITE_NAME]", "[LINK]", "[SITE_URL]");
			$replace = array($row['user_name'], $settings->set['site_name'], $link, $settings->set['site_url']);
			$body = str_replace($search, $replace, $template['template_body']);
			$mailer->sendMail($row['user_email'], $template['template_subject'], $body);
			return true;	
		}
		$msg_error[] = 'That site cannot be found.';
		return false;
	}
	
	public function disapproveSite($site_id)
	{
		global $db, $settings, $mailer, $msg_error;
		$row = $db->first("SELECT s.site_name, u.user_name, u.user_email FROM sites s LEFT JOIN users u ON u.user_id = s.site_owner WHERE site_id = ".$site_id." LIMIT 1");
		if($row)
		{
			$data['site_active'] = 'Disapproved';
			$db->update("sites", $data, "site_id=".$site_id);
				//mail user with activation code
			$template = $settings->getTemplate(4);
			$link = $settings->set['site_url'] . '/index.php?page=site_view&id=' . $site_id;
			$search = array("[USER_NAME]", "[SITE_NAME]", "[LINK]", "[SITE_URL]");
			$replace = array($row['user_name'], $settings->set['site_name'], $link, $settings->set['site_url']);
			$body = str_replace($search, $replace, $template['template_body']);
			$mailer->sendMail($row['user_email'], $template['template_subject'], $body);
			return true;	
		}
		$msg_error[] = 'That site cannot be found.';
		return false;
	}

	public function getSite($site_id)
	{
		global $db;
		$sql = $db->query("SELECT * FROM sites WHERE site_id = '" . intval($site_id) . "' LIMIT 1");
		if ($db->numrows($sql))
			return $db->fetch($sql);
		else
			return false;
	}

	public function editSite($site_id)
	{
		global $db, $msg_error, $msg_ok, $user;
		$site_name = sanitize($_POST['site_name']);
		$site_url = sanitize(str_replace("http://", "", $_POST['site_url']));
		$site_banner = sanitize(str_replace("http://", "", $_POST['site_banner']));
		$site_description = sanitize($_POST['site_description']);
		if (!$site_name)
			$msg_error[] = 'You must enter a site name.';
		if (!$site_url)
			$msg_error[] = 'You must enter a site URL.';
		if (!$site_description)
			$msg_error[] = 'You must enter a site description.';

		$data = array("site_name" => $site_name, "site_url" => $site_url, "site_banner" => $site_banner, "site_description" => $site_description);
		if (empty($msg_error))
		{
			
			if($user->user_level == 9 && isset($_POST['site_active']))
			{
				$data['site_active'] = $_POST['site_active'];
			}
			$db->update("sites", $data, "site_id = " . intval($site_id));
			$msg_ok = 'Your site has been updated.';
			return true;
		}
		return false;
	}

	public function getSites($where = false, $sort = false, $start = 0)
	{
		global $db, $settings, $pager;
		
		$pager = new Paginator();
		$counter = countRows('sites', $where);
		$pager->items_total = $counter;
		$pager->default_ipp = $settings->set['site_per_page'];
		$pager->paginate();
		
		if ($counter == 0) {
			$pager->limit = "";
		}
		
		isset($where['op']) ? $op = sanitize($where['op']) : $op = " LIKE ";
		($where) ? $where = "AND " . sanitize($where['field']) . $op . "'".$where['value']."'" : "";
		($sort) ? $order = sanitize($sort) : $order = "s.site_votes DESC";
		($start) ? $start = intval($start) : $start = 0;

		$sql = "SELECT s.*, u.*
			FROM sites s 
			LEFT JOIN users u ON u.user_id = s.site_owner 
			WHERE 1=1 " . $where . "
			ORDER BY " . $order . " " . $pager->limit;
		$row = $db->fetch_all($sql);

		if ($row)
			return $row;
		else
			return false;
	}

	public function submitSite()
	{
		global $db, $msg_error, $msg_ok, $settings, $mailer;
		if (!$_POST['site_name'])
			$msg_error[] = 'You must enter a site name.';
		if (!$_POST['site_url'])
			$msg_error[] = 'You must enter a site URL.';
		if (!$_POST['site_description'])
			$msg_error[] = 'You must enter a site description.';

		if (empty($msg_error))
		{
			$insert_id = $this->addSite();
			if($settings->set['site_admin_notification'] == 'On')
			{
				//mail user with activation code
				$template = $settings->getTemplate(6);
				$link = $settings->set['site_url'] . '/index.php?page=site_view&id=' . $insert_id;
				$search = array("[SITE_NAME]", "[LINK]");
				$replace = array($settings->set['site_name'], $link);
				$body = str_replace($search, $replace, $template['template_body']);
				$mailer->sendMail($settings->set['site_email'], $template['template_subject'], $body);		
			}
			if ($settings->set['site_admin_site_activation'] == 'On')
				$msg_ok = 'Your site, ' . $_POST['site_name'] . ' has been added.  You site will be shown once an administrator approves it.';
			else
				$msg_ok = 'Your site, ' . $_POST['site_name'] . ' has been added.  It is now visible on the site.';
			return true;
		}
		return false;
	}

	public function vote($site_id)
	{
		global $db, $msg_error, $msg_ok;
		if (!$this->checkVoted($site_id))
		{
			$vdata = array("vote_site_id" => $site_id, "vote_ip" => $_SERVER['REMOTE_ADDR'], "vote_time" => "NOW()");
			$db->insert("votes", $vdata);
			$sdata = array("site_votes" => "INC(1)", "site_votes_total" => "INC(1)");
			$db->update("sites", $sdata, "site_id = " . $site_id);
			return true;
		}
		return false;
	}

	public function out($site_id)
	{
		global $db, $msg_error, $msg_ok;
		$vdata = array("click_site_id" => $site_id, "click_ip" => $_SERVER['REMOTE_ADDR'], "click_time" => "NOW()");
		$db->insert("clicks", $vdata);
		$sdata = array("site_clicks" => "INC(1)", "site_clicks_total" => "INC(1)");
		$db->update("sites", $sdata, "site_id = " . $site_id);
		return true;
	}

	public function getVotes($site_id, $time)
	{
		global $db;

		$sql = $db->query("SELECT * FROM votes WHERE vote_site_id = '" . $site_id . "'  AND TO_DAYS(NOW())-TO_DAYS(vote_time)" . $time . "");
		$votes = $db->numrows($sql);
		return $votes;
	}

	public function getClicks($site_id, $time)
	{
		global $db;

		$sql = $db->query("SELECT * FROM clicks WHERE click_site_id = '" . $site_id . "'  AND TO_DAYS(NOW())-TO_DAYS(click_time)" . $time . "");
		$votes = $db->numrows($sql);
		return $votes;
	}

	private function checkVoted($site_id)
	{
		global $db;
		$vote_time = date("Y-m-d");
		$vote_ip = $_SERVER['REMOTE_ADDR'];
		$sql = $db->query("SELECT * FROM votes WHERE vote_time LIKE '" . $vote_time . "%' AND vote_ip LIKE '" . $vote_ip . "' AND vote_site_id = " . $site_id . " LIMIT 1");
		if ($db->numrows($sql))
			return true;
		else
			return false;
	}

	private function addSite()
	{
		global $db, $user, $settings;
		$site_name = sanitize($_POST['site_name']);
		$site_url = sanitize(str_replace("http://", "", $_POST['site_url']));
		$site_description = sanitize($_POST['site_description']);
		$site_banner = sanitize(str_replace("http://", "", $_POST['site_banner']));

		$active = 'No';
		if ($settings->set['site_admin_site_activation'] == 'No')
			$active = 'Yes';
		$data = array('site_name' => $site_name, 'site_url' => $site_url, 'site_description' => $site_description, 'site_banner' => $site_banner, 'site_active' => $active, 'site_owner' => $user->user_info['user_id']);
		return $db->insert("sites", $data);
	}
}

?>