<?php

/**
 * Class class_users.php
 * @author starr-gaming.com
 * @copyright 2010
 */

if (!defined("VALID_PHP"))
	die('Direct access to this location is not allowed.');

class User
{
	public $logged_in = false;
	public $user_info = array();
	public $user_name = "";
	public $user_level = 0;
	public $cookie_id = "";
	private $email_token = "";

	function __construct()
	{
		$this->startSession();
	}
	
	public function forgotPassword()
	{
		global $db, $mailer, $msg_error, $settings, $msg_ok;
		$row = $this->getUserInfo($_POST['user_name']);
		if(!$row)
			$msg_error[] = 'An account with that username cannot be found.';

		if ($settings->set['site_captcha'] == 'On')
		{
			if (!$this->checkPin($this->generatePin($_SESSION['pin_value']), $_POST['user_pin']))
				$msg_error[] = 'The captcha code you entered was not correct.';
		}
		
		if(empty($msg_error))
		{
			$rand = generateRandomString(8);
			$password = md5($rand);
			$data['user_password'] = $password;
			$db->update("users", $data, "user_id = " . $row['user_id']);
			$template = $settings->getTemplate(2);
			$search = array("[USER_NAME]", "[SITE_NAME]", "[PASSWORD]", "[SITE_URL]");
			$replace = array($_POST['user_name'], $settings->set['site_name'], $password, $settings->set['site_url']);
			$body = str_replace($search, $replace, $template['template_body']);
			$mailer->sendMail($row['user_email'], $template['template_subject'], $body);
			$msg_ok = 'Your password has been updated and an email with your new password has been sent to you.';
			return true;
		}
		return false;
	}
	
	public function getUserSort()
	{
		$array = array(
			"NA" => " -- Reset Sort -- ", 
			"user_id-ASC" => "ID &uarr;",
			"user_id-DESC" => "ID &darr;",
			"user_name-ASC" => "Name &uarr;",
			"user_name-DESC" => "Name &darr;",
			"user_last_active-ASC" => "Votes &uarr;",
			"user_last_active-DESC" => "Votes &darr;",
		);
		$return = "";
		foreach($array AS $key =>$value)
		{
			$selected = "";
			if(isset($_GET['sort']) && $key == $_GET['sort'])
				$selected = 'selected=selected';
			$return .= '<option value="'.$key.'" '.$selected.'>'.$value.'</option>';
		}
		return $return;
	}

	public function getUser($user_id)
	{
		global $db;
		$sql = $db->query("SELECT * FROM users WHERE user_id = '" . intval($user_id) . "' LIMIT 1");
		if ($db->numrows($sql))
			return $db->fetch($sql);
		else
			return false;
	}

	public function getUsers($where = false, $sort = false, $start = 0)
	{
		global $db, $settings, $pager;
		
		$pager = new Paginator();
		$counter = countRows('users');
		$pager->items_total = $counter;
		$pager->default_ipp = $settings->set['site_per_page'];
		$pager->paginate();
		
		if ($counter == 0) {
			$pager->limit = "";
		}

		($where) ? $where = "AND " . sanitize($where) : "";
		($sort) ? $order = sanitize($sort) : $order = "user_id DESC";
		($start) ? $start = intval($start) : $start = 0;

		$sql = "SELECT * FROM users	WHERE 1=1 " . $where . " ORDER BY " . $order . " " . $pager->limit;
		$row = $db->fetch_all($sql);

		if ($row)
			return $row;
		else
			return false;
	}

	public function register()
	{
		global $settings, $msg_ok, $msg_error, $mailer;

		if ($_POST['user_password'] != $_POST['user_password_repeat'])
			$msg_error[] = 'The passwords you entered did not match.';

		if (!$_POST['user_password'])
			$msg_error[] = "Please enter a valid password!";
		else
		{
			$_POST['user_password'] = stripslashes($_POST['user_password']);
			if (strlen($_POST['user_password']) < 6)
				$msg_error[] = "Password must be at least 6 characters long";
			elseif (!preg_match("/^([0-9a-z])+$/i", ($_POST['user_password'] = trim($_POST['user_password']))))
				$msg_error[] = "Passwords can only contain alphanumeric characters";
			elseif ($_POST['user_password'] != $_POST['user_password_repeat'])
				$msg_error[] = "The passwords you entered did not match!";
		}

		if ($settings->set['site_captcha'] == 'On')
		{
			if (!$this->checkPin($this->generatePin($_SESSION['pin_value']), $_POST['user_pin']))
				$msg_error[] = 'The captcha code you entered was not correct.';
		}

		if (empty($msg_error))
		{
			$this->email_token = ($settings->set['site_email_verification'] == 'On') ? generateRandomID() : 0;
			if ($this->addUser())
			{
				if ($settings->set['site_email_verification'] == 'On')
				{
					//mail user with activation code
					$template = $settings->getTemplate(1);
					$link = $settings->set['site_url'] . '/index.php?page=login&token='.$this->email_token.'&email='.$_POST['user_email'];
					$search = array("[USER_NAME]", "[SITE_NAME]", "[PASSWORD]", "[LINK]", "[SITE_URL]");
					$replace = array($_POST['user_name'], $settings->set['site_name'], $_POST['user_password'], $link, $settings->set['site_url']);
					$body = str_replace($search, $replace, $template['template_body']);
					$mailer->sendMail($_POST['user_email'], $template['template_subject'], $body);
					
					$msg_ok = 'Thank you for registering.  A confirmation email has been sent to your address.  Please click the link in the email to activate your account.';
				}
				else
				{
					$msg_ok = 'Thank you for registering.  Your account is active and you may now login.';
				}
			}
		}
	}

	public function login()
	{
		global $msg_error, $db, $msg_ok;
		if (!(trim($_POST['user_name'])))
			$msg_error[] = 'Please enter a valid username';
		if (!(trim($_POST['user_password'])))
			$msg_error[] = 'Please enter a valid password';

		$result = $this->checkLoginInfo($_POST['user_name'], $_POST['user_password']);
		if ($result == 0)
			$msg_error[] = 'An account with that username cannot be found';
		elseif ($result == 1)
			$msg_error[] = 'The password you entered was not correct.';
		elseif ($result == 2)
			$msg_error[] = 'Your account has not been activated yet.';

		if (empty($msg_error))
		{
			$this->user_info = $this->getUserInfo($_POST['user_name']);
			$this->user_name = $_SESSION['user_name'] = $this->user_info['user_name'];
			$this->user_level = $_SESSION['user_level'] = $this->user_info['user_level'];
			$this->cookie_id = $_SESSION['cookie_id'] = generateRandomId();
			$this->logged_in = true;
			$data = array('user_cookie_id' => $this->cookie_id, 'user_last_active' => 'NOW()', 'user_ip' => $_SERVER['REMOTE_ADDR']);
			$db->update("users", $data, "user_name LIKE '" . $db->escape($this->user_name) . "'");
			if (isset($_POST['user_remember']))
			{
				setcookie("TT_COOKIE", $this->username, time() + COOKIE_EXPIRE, COOKIE_PATH);
				setcookie("TT_COOKIE_ID", $this->cookie_id, time() + COOKIE_EXPIRE, COOKIE_PATH);
			}
			$msg_ok = 'You have logged in.';
			return true;
		}
		else
		{
			return false;
		}
	}

	public function logout()
	{
		global $db;

		if (isset($_COOKIE['TT_COOKIE']) && isset($_COOKIE['TT_COOKIE_ID']))
		{
			setcookie("TT_COOKIE", "", time() - COOKIE_EXPIRE, COOKIE_PATH);
			setcookie("TT_COOKIE_ID", "", time() - COOKIE_EXPIRE, COOKIE_PATH);
		}

		unset($_SESSION['user_name']);
		unset($_SESSION['cookie_id']);

		$this->logged_in = false;
		$this->username = "Guest";
		$this->userlevel = 0;
	}

	public function checkPin($generated, $submitted)
	{
		return ($generated == $submitted) ? true : false;
	}

	public function generatePin($submitted)
	{
		return substr(md5($submitted), 15, 8);
	}

	public function unlinkPin()
	{
		if (isset($_SESSION['pin_value']))
		{
			unlink(BASE . 'cache/site_pin_' . $_SESSION['pin_value'] . '.jpg');
			unset($_SESSION['pin_value']);
		}
	}

	public function showPin($pin, $generated)
	{
		$font = 10;
		$width = imagefontwidth($font) * strlen($generated);
		$height = imagefontheight($font);

		$im = @imagecreate($width, $height);
		//cell background
		$bg = imagecolorallocate($im, 255, 255, 255);
		//text color
		$textcolor = imagecolorallocate($im, 0, 0, 0);
		imagestring($im, $font, 0, 0, $generated, $textcolor);
		touch(BASE . 'cache/site_pin_' . $pin . '.jpg');
		imagejpeg($im, BASE . 'cache/site_pin_' . $pin . '.jpg');

		$output = '<img src="cache/site_pin_' . $pin . '.jpg" alt="Please type the code you see in the box"/>';

		imagedestroy($im);

		return $output;
	}

	public function activateUser()
	{
		global $db, $msg_error, $msg_ok;
		$user_email = ($this->isValidEmail($_GET['email'])) ? $_GET['email'] : "";
		$user_token = (strlen($_GET['token']) == 32) ? $_GET['token'] : "";
		if (!$user_email)
			$msg_error[] = 'The email address is not valid.';
		if (!$user_token)
			$msg_error[] = 'The token is not valid.';
		if (!$this->validateToken($user_token, $user_email))
			$msg_error[] = 'The information entered is incorrect or the account is already active.';
		if (empty($msg_error))
		{
			$this->setUserActive($user_token, $user_email);
			$msg_ok = 'Your account has been activated, you may now login.';
		}
	}
	
	public function updateProfile($user_id = false)
	{
		global $db, $msg_ok, $msg_error;
		
		if($user_id)
			$user_id = intval($user_id);
		else
			$user_id = $this->user_info['user_id'];
		
		if (empty($_POST['user_email']))
		{
			$msg_error[] = 'Please enter an email address.';
		}
		else
		{
			if ($this->emailExists($_POST['user_email']) && $this->user_info['user_email'] != $_POST['user_email'] && $this->user_level != 9)
				$msg_error[] = 'Email address is already in use.';
			if (!$this->isValidEmail($_POST['user_email']))
				$msg_error[] = 'Email address is not valid.';
		}
		if(empty($msg_error))
		{
			$data = array('user_email' => sanitize($_POST['user_email']));
			
			if($this->user_level == 9 && isset($_POST['user_active']))
			{
				$data['user_active'] = $_POST['user_active'];
			}
				
			if(isset($_POST['user_password']))
				$data['user_password'] = md5($_POST['user_password']);
			$db->update("users", $data, "user_id = " . $user_id);
			return true;
		}
		return false;
	}
	
	public function updateUserInfo()
	{
		$this->user_info = $this->getUserInfo($this->user_name);
		$this->user_name = $_SESSION['user_name'] = $this->user_info['user_name'];
		$this->user_level = $_SESSION['user_level'] = $this->user_info['user_level'];
	}

	private function setUserActive($user_token, $user_email)
	{
		global $db;
		$data = array('user_email_token' => 0, 'user_active' => 'Yes');
		$db->update('users', $data, "user_email = '" . $db->escape($user_email) . "' AND user_email_token = '" . $db->escape($user_token) . "'");
	}

	private function validateToken($user_token, $user_email)
	{
		global $db;
		$sql = $db->query("SELECT user_id FROM users WHERE user_email LIKE '" . $db->escape($user_email) . "' AND user_email_token LIKE '" . $db->escape($user_token) . "' LIMIT 1");
		if ($db->numrows($sql))
			return true;
		else
			return false;
	}

	private function addUser()
	{
		global $db, $msg_error, $settings;

		if (empty($_POST['user_name']))
			$msg_error[] = 'Please enter a user name.';
		if (empty($_POST['user_password']))
			$msg_error[] = 'Please enter a password.';
		if (empty($_POST['user_email']))
		{
			$msg_error[] = 'Please enter an email address.';
		}
		else
		{
			if ($this->emailExists($_POST['user_email']))
				$msg_error[] = 'Email address is already in use.';
			if (!$this->isValidEmail($_POST['user_email']))
				$msg_error[] = 'Email address is not valid.';
		}
		if ($return = $this->userNameExists($_POST['user_name']))
		{
			if ($return == 1)
				$msg_error[] = 'User name must be at least 4 and 20 characters long.';
			if ($return == 2)
				$msg_error[] = 'Invalid characters in user name, only alpha numeric characters allowed.';
			if ($return == 3)
				$msg_error[] = 'This user name is already taken.';
		}

		$user_active = 'Yes';
		if ($settings->set['site_email_verification'] == 'Yes')
			$user_active = 'No';

		if (empty($msg_error))
		{
			$data = array('user_name' => sanitize($_POST['user_name']), 'user_email' => sanitize($_POST['user_email']), 'user_password' => md5($_POST['user_password']), 'user_created' => 'NOW()', 'user_active' => $user_active, 'user_email_token' => $this->email_token);
			$db->insert("users", $data);
			return true;
		}
		return false;
	}

	private function startSession()
	{
		session_start();

		$this->logged_in = $this->checkLogin();

		if (!$this->logged_in)
		{
			$this->user_name = $_SESSION['user_name'] = "Guest";
			$this->user_level = 0;
		}
	}

	private function checkLogin()
	{
		if (isset($_COOKIE['TT_COOKIE']) && isset($_COOKIE['TT_COOKIE_ID']))
		{
			$this->username = $_SESSION['user_name'] = $_COOKIE['TT_COOKIE'];
			$this->cookie_id = $_SESSION['cookie_id'] = $_COOKIE['TT_COOKIE_ID'];
		}

		if (isset($_SESSION['user_name']) && isset($_SESSION['cookie_id']) && $_SESSION['user_name'] != "Guest")
		{
			if (!$this->checkUserCookie($_SESSION['user_name'], $_SESSION['cookie_id']))
			{
				unset($_SESSION['user_name']);
				unset($_SESSION['cookie_id']);
				return false;
			}

			$this->user_info = $this->getUserInfo($_SESSION['user_name']);
			$this->user_name = $this->user_info['user_name'];
			$this->cookie_id = $this->user_info['user_cookie_id'];
			$this->user_level = $this->user_info['user_level'];
			return true;
		}
		else
		{
			return false;
		}
	}

	private function checkUserCookie($user_name, $cookie_id)
	{
		global $db;
		$sql = $db->query("SELECT user_cookie_id FROM users WHERE user_name LIKE '" . $db->escape($user_name) . "' LIMIT 1");
		if ($db->numrows($sql))
		{
			$row = $db->fetch($sql);
			if ($cookie_id == $row['user_cookie_id'])
				return true;
		}
		return false;
	}

	private function checkLoginInfo($user_name, $user_password)
	{
		global $db;
		$user_name = sanitize($user_name);
		$user_password = sanitize($user_password);
		$query = $db->query("SELECT user_active, user_password FROM users WHERE user_name LIKE '" . $db->escape($user_name) . "' LIMIT 1");
		if (!$query)
			return 0;
		$row = $db->fetch($query);
		if ($row['user_active'] != 'Yes')
			return 2;

		$entered_password = md5($user_password);
		if ($row['user_password'] == $entered_password)
			return 99;
		else
			return 1;
	}

	private function getUserInfo($user_name)
	{
		global $db;
		$user_name = sanitize($user_name);
		$sql = $db->query("SELECT * FROM users WHERE user_name LIKE '" . $db->escape($user_name) . "' LIMIT 1");
		if ($db->numrows($sql))
			return $db->fetch($sql);
		else
			return false;
	}

	private function emailExists($user_email)
	{
		global $db;

		$user_email = sanitize($user_email);
		$sql = $db->query("SELECT user_id FROM users WHERE user_email LIKE '" . $db->escape($user_email) . "' LIMIT 1");
		if ($db->numrows($sql))
			return true;
		else
			return false;
	}

	private function userNameExists($user_name)
	{
		global $db;

		if (strlen($db->escape($user_name, true)) < 4 || strlen($db->escape($user_name, true)) > 20)
			return 1;

		$alpha_num = str_replace(" ", "", $user_name);
		if (!ctype_alnum($alpha_num))
			return 2;

		$sql = $db->query("SELECT user_id FROM users WHERE user_name LIKE '" . sanitize($user_name) . "' LIMIT 1");
		if ($db->numrows($sql) > 0)
			return 3;
		else
			return false;
	}

	private function isValidEmail($email)
	{
		if (filter_var($email, FILTER_VALIDATE_EMAIL))
			return true;
		else
			return false;
	}
}

?>