<?php

/**
 * functions.php
 * @author starr-gaming.com
 * @copyright 2010
 */

if (!defined("VALID_PHP"))
	die('Direct access to this location is not allowed.');

function countRows($table, $where = false)
{
	global $db;
	
	isset($where['op']) ? $op = sanitize($where['op']) : $op = " LIKE ";
	($where) ? $where = " WHERE  " . sanitize($where['field']) . $op . "'".$where['value']."'" : "";
	$sql = $db->query("SELECT COUNT(*) AS cnt FROM " . $table .$where);
	$row = $db->fetch($sql);
	return $row['cnt'];
}

function redirect($location, $delay = 0)
{
	if($delay > 0)
	{
			echo '<meta http-equiv="refresh" content="' . $delay . ';url=' . $location . '" />';
	}
	else
	{
		if (!headers_sent())
			header('Location: ' . $location);
		else
		{
			echo '<script type="text/javascript">';
			echo 'window.location.href="' . $location . '";';
			echo '</script>';
			echo '<noscript>';
			echo '<meta http-equiv="refresh" content="0;url=' . $location . '" />';
			echo '</noscript>';
		}
	}
}

function display_message()
{
	global $msg_ok, $msg_error, $msg_alert, $msg_info;
	if (!empty($msg_ok))
	{
		echo '<div class="msg_ok">' . $msg_ok . '</div>';
	}
	if (!empty($msg_error))
	{
		if(is_array($msg_error))
		{
			echo '<div class="msg_error">';
			foreach($msg_error AS $msg)
				echo '<li>' . $msg . '</li>';
			echo '</div>';
		}
		else
		{
		echo '<div class="msg_error">' . $msg_error . '</div>';
		}
	}
	if (!empty($msg_info))
	{
		echo '<div class="msg_info">' . $msg_info . '</div>';
	}
	if (!empty($msg_alert))
	{
		echo '<div class="msg_alert">' . $msg_alert . '</div>';
	}
}

function sanitize($string, $trim = false)
{
	$string = filter_var($string, FILTER_SANITIZE_STRING);
	$string = trim($string);
	$string = stripslashes($string);
	$string = strip_tags($string);
	$string = str_replace(array('', '', '', ''), array("'", "'", '"', '"'), $string);
	if ($trim)
		$string = substr($string, 0, $trim);

	return $string;
}

function generateRandomID()
{
	return md5(generateRandomString(16));
}

function generateRandomString($length)
{
	$randstr = "";
	for ($i = 0; $i < $length; $i++)
	{
		$randnum = mt_rand(0, 61);
		if ($randnum < 10)
		{
			$randstr .= chr($randnum + 48);
		} elseif ($randnum < 36)
		{
			$randstr .= chr($randnum + 55);
		}
		else
		{
			$randstr .= chr($randnum + 61);
		}
	}
	return $randstr;
}

function ob_replace($buffer)
{
	global $page_title, $meta_keywords, $meta_description, $settings;
	
	$page_title = ($page_title) ? $page_title . ' - ' . $settings->set['site_name'] : $settings->set['site_name'];
	$meta_keywords = ($meta_keywords) ? $meta_keywords : $settings->set['site_meta_keywords'];
	$meta_description = ($meta_description) ? $meta_description : $settings->set['site_meta_description'];
		
	$search = array("{{PAGE_TITLE}}", "{{META_KEYWORDS}}", "{{META_DESCRIPTION}}");
	$replace = array($page_title, $meta_keywords, $meta_description);
	
	$buffer = str_replace($search, $replace, $buffer);
	
	return $buffer;
}

?>