<?php

/**
 * Panel.php
 * @author starr-gaming.com
 * @copyright 2010
 */
 
$page_title = "User Control Panel";

if (!defined("VALID_PHP"))
	die('Direct access to this location is not allowed.');

if(!$user->logged_in)
	redirect("/index.php?page=login");
	
if(isset($_POST['submit']))
{
	$return = $user->updateProfile();
	if($return)
	{
		$msg_ok = 'Your account has been updated.';
		$user->updateUserInfo();
	}
}

if(isset($_GET['id']) && isset($_GET['action']))
{
	$site_id = intval($_GET['id']);
	if($_GET['action'] == 'delete')
	{
		$site = $sites->getSite($site_id);
		if($site['site_owner'] == $user->user_info['user_id'])
		{
			if($sites->deleteSite($site_id))
				$msg_ok = 'You have deleted the site.';
		}
	}
}
	
if(isset($_GET['siteadded']))
{
	if($settings->set['site_admin_site_activation'] == 'On')
		$msg_ok = 'Your site has been added.  You site will be shown once an administrator approves it.';
	else
		$msg_ok = 'Your site has been added.  It is now visible on the site.';
}
	
$rows = $sites->getSites(array("field" => "site_owner", "value" => $user->user_info['user_id'], "op" => "="));

?>
<?php display_message(); ?>
<h1><?php echo $page_title; ?></h1>
<h2>Your Sites</h2>
<table class="box wide">
	<thead>
		<tr>
			<th colspan="4">Your Sites</th>
		</tr>
		<tr>
			<td>Site</td>
			<td>Current Votes</td>
			<td>Current Clicks</td>
			<td></td>
		</tr>
	</thead>
	<tbody>
<?php if($rows): ?>
	<?php foreach ($rows AS $row): ?>
		<tr>
			<td><a href="/index.php?page=site_view&id=<?php echo $row['site_id']; ?>"><?php echo $row['site_name']; ?></a></td>
			<td><?php echo $row['site_votes']; ?></td>
			<td><?php echo $row['site_clicks']; ?></td>
			<td>
				<?php $image = ($row['site_active'] == 'Yes') ? 'accept' : 'clock' ?>
				<?php $title = ($row['site_active'] == 'Yes') ? 'Site Active' : 'Site Inactive' ?>
				<a href="javascript:ask('Are you sure you want to delete this site?', '/index.php?page=panel&action=delete&id=<?php echo $row['site_id']; ?>')"><img src="/images/delete.png" title="Delete Site" class="tooltip" /></a>
				<img src="/images/<?php echo $image ?>.png" title="<?php echo $title ?>" class="tooltip" />
				<a href="/index.php?page=site_edit&id=<?php echo $row['site_id']; ?>"><img src="/images/edit.png" title="Edit Site" class="tooltip" /></a>
				<a href="/index.php?page=site_view&id=<?php echo $row['site_id']; ?>"><img src="/images/info.png" title="Site Profile" class="tooltip" /></a>
				<a href="/index.php?page=site_code&id=<?php echo $row['site_id']; ?>"><img src="/images/code.png" title="Voting Code" class="tooltip" /></a>
			</td>
		</tr>
	<?php endforeach; ?>
	<?php else: ?>
	<tr class="alert">
		<td colspan="4">You have not added a site yet, <a href="/index.php?page=add_site">Click Here</a> to add one.</td>
	</tr>
<?php endif; ?>
	</tbody>
</table>
<h2>Your Profile</h2>
<form action="/index.php?page=panel" method="post">
<table class="box">
	<thead>
		<tr>
			<td colspan="2">Edit Account</td>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>Login Name</td>
			<td><input type="text" class="input" name="user_name" value="<?php echo $user->user_name; ?>" disabled="disabled" /></td>
		</tr>
		<tr>
			<td>Email Address</td>
			<td><input type="text" class="input" name="user_email" value="<?php echo $user->user_info['user_email']; ?>" /></td>
		</tr>
		<tr>
			<td>Password</td>
			<td><input type="password" class="input" name="user_password" value="" /></td>
		</tr>
	</tbody>
	<tfoot>
		<tr>
			<td colspan="2"><input type="submit" name="submit" value="Update Profile" class="button" /></td>
		</tr>
	</tfoot>
</table>
</form>