<?php

/**
 * Site_edit.php
 * @author starr-gaming.com
 * @copyright 2010
 */

if (!defined("VALID_PHP"))
	die('Direct access to this location is not allowed.');

if(!$user->logged_in)
	redirect("/index.php?page=login");
	
$site_id = intval($_GET['id']);

$site = $sites->getSite($site_id);
if(!$site)
	$msg_error[] = 'That site cannot be found.';
if($site['site_owner'] != $user->user_info['user_id'])
	$msg_error[] = 'You are not the owner of this site.';
 
$page_title = "Editing " . $site['site_name'];

if(empty($msg_error) && isset($_POST['submit']))
	$return = $sites->editSite($site_id);
	
$site = $sites->getSite($site_id);

?>
<?php display_message(); ?>
<h1><?php echo $page_title; ?></h1>
<form action="/index.php?page=site_edit&id=<?php echo $site_id ?>" method="post">
	<table class="box">
		<thead>
			<tr>
				<th colspan="2">Editing Your Site</th>
			</tr>
		</thead>
		<tbody>
			<tr>
				<td>Site Name:</td>
				<td>
					<input type="text" class="input" name="site_name" value="<?php echo $site['site_name'];?>" />
					<img src="/images/info.png" class="tooltip" title="The name of your site." />
				</td>
			</tr>
			<tr>
				<td>Site URL:</td>
				<td>
					<input type="text" class="input" name="site_url" value="<?php echo $site['site_url'];?>" />
					<img src="/images/info.png" class="tooltip" title="The URL to your site, eg: www.yoursite.com." />
				</td>
			</tr>
			<tr>
				<td>Site Banner:</td>
				<td>
					<input type="text" class="input" name="site_banner" value="<?php echo $site['site_banner'];?>" />
					<img src="/images/info.png" class="tooltip" title="A URL to a 468x60 pixel banner, eg: www.yoursite.com/yourbanner.gif." />
				</td>
			</tr>
			<tr>
				<td>Site Description:</td>
				<td>
					<textarea class="textarea" name="site_description"><?php echo $site['site_description'];?></textarea>
					<img src="/images/info.png" class="tooltip" title="A detailed description of your site." />
				</td>
			</tr>
		</tbody>
		<tfoot>
			<tr>
				<td colspan="2"><input type="submit" name="submit" value="Edit Site" class="button" /></td>
			</tr>
		</tfoot>
	</table>
</form>